[meta-oe] libcereal: add ptest support

Message ID 20220310053040.4056340-1-mingli.yu@windriver.com
State Under Review
Headers show
Series [meta-oe] libcereal: add ptest support | expand

Commit Message

Yu, Mingli March 10, 2022, 5:30 a.m. UTC
From: Mingli Yu <mingli.yu@windriver.com>

Add ptest support.

Signed-off-by: Mingli Yu <mingli.yu@windriver.com>
---
 .../recipes-support/libcereal/files/run-ptest  | 12 ++++++++++++
 .../libcereal/libcereal_1.3.2.bb               | 18 +++++++++++++++---
 2 files changed, 27 insertions(+), 3 deletions(-)
 create mode 100755 meta-oe/recipes-support/libcereal/files/run-ptest

Patch

diff --git a/meta-oe/recipes-support/libcereal/files/run-ptest b/meta-oe/recipes-support/libcereal/files/run-ptest
new file mode 100755
index 000000000..9bc480aa7
--- /dev/null
+++ b/meta-oe/recipes-support/libcereal/files/run-ptest
@@ -0,0 +1,12 @@ 
+#!/bin/sh
+
+cd tests
+for atest in test_* ; do
+    rm -rf tests.log
+    ./${atest} > tests.log 2>&1
+    if [ $? = 0 ] ; then
+        echo "PASS: ${atest}"
+    else
+        echo "FAIL: ${atest}"
+    fi
+done
diff --git a/meta-oe/recipes-support/libcereal/libcereal_1.3.2.bb b/meta-oe/recipes-support/libcereal/libcereal_1.3.2.bb
index 08291d2db..fc58a42d2 100644
--- a/meta-oe/recipes-support/libcereal/libcereal_1.3.2.bb
+++ b/meta-oe/recipes-support/libcereal/libcereal_1.3.2.bb
@@ -12,17 +12,29 @@  LIC_FILES_CHKSUM = "\
     file://include/cereal/external/rapidjson/msinttypes/LICENSE;md5=dffce65b98c773976de2e338bd130f46 \
 "
 
+DEPENDS = " ${@bb.utils.contains('DISTRO_FEATURES', 'ptest', 'boost', '', d)} "
+
 PROVIDES += "${PN}-dev"
 
 PV .= "+git${SRCPV}"
 SRCREV = "ebef1e929807629befafbb2918ea1a08c7194554"
-SRC_URI = "git://github.com/USCiLab/cereal.git;branch=master;protocol=https"
+SRC_URI = "git://github.com/USCiLab/cereal.git;branch=master;protocol=https \
+           file://run-ptest \
+"
 
 S = "${WORKDIR}/git"
 
-inherit cmake pkgconfig
+inherit cmake pkgconfig ptest
+
+PACKAGECONFIG ??= "${@bb.utils.contains('PTEST_ENABLED', '1', 'with-tests', '', d)}"
+PACKAGECONFIG[with-tests] = "-DBUILD_TESTS=ON -DSKIP_PORTABILITY_TEST=ON,,"
+
+EXTRA_OECMAKE = "${@bb.utils.contains('DISTRO_FEATURES', 'ptest', '', '-DJUST_INSTALL_CEREAL=ON', d)}"
 
-EXTRA_OECMAKE = "-DJUST_INSTALL_CEREAL=ON"
+do_install_ptest() {
+    install -d ${D}${PTEST_PATH}/tests
+    cp ${B}/unittests/test_*  ${D}${PTEST_PATH}/tests
+}
 
 ALLOW_EMPTY:${PN} = "1"